#ifndef RADIATION_H
#define RADIATION_H

#include	"infrastructure/EKSObject.h"
class	Radiation_def;
class	State_variable;
class	Equation_set;
class	Equation_iterator;

extern	Type*	Radiation_Type_pointer;

/*
** Base class for the calculation of Radiation.
*/


class Radiation : public EKSObject {
protected:
	Radiation(Metaclass* meta, Radiation_def* def);
	Radiation(Radiation& c);
	Radiation(APL* theAPL);
	~Radiation();
public:
	Type*	getDirectType();

////virtual Equation_set*	generate_equations(State_vector& state_vector,
////					   EKSObject*  surf,
////					   Equation_iterator  surf_eqn_iter) = 0;
////virtual	Equation_set*	combine_equations(Equation_iterator surf1_eqn_iter,
////					  State_variable*  surf_air_node,
////					  Equation_iterator  surf2_eqn_iter,
////					  State_variable*  surf2_air_node,
////					  EKSObject*  data_supplier) = 0;
virtual void		add_coupling(Equation_iterator  surf1_eqn_iter,
				     State_variable*  surf1,
				     Equation_iterator	region2_eqn_iter,
				     State_variable*  node_in_region2,
				     EKSObject*  data_supplier) = 0;
virtual	void		inject_energy(Equation_iterator  surf_eqn_iter,
				      State_variable*  node_in_surf,
				      Energy  gain) = 0;
};


inline
Type*	Radiation::getDirectType()
{
	return TYPE_OF(Radiation);
};
#endif
