#ifndef LIST_H
#define	LIST_H

#include	<generic.h>
#include	<stream.h>
#include	<stdlib.h>
#include	"infrastructure/EKSObject.h"

			// type itself may be parameterized, so must be 1st part
			// of result or it won't be expanded - unlike generic.h
#define sethandler(generic,type,x) name3(type,generic,_sethandler)(x)
#define template_declare(a,t) name2(a,declare)(t)
#define template_declare2(a,t1,t2) name2(a,declare)(t1,t2)
#define template_define(a,t) name2(a,define)(t)
#define template_define2(a,t1,t2) name2(a,define)(t1,t2)
#define template_implement(a,t) name2(a,implement)(t)
#define template_implement2(a,t1,t2) name2(a,implement)(t1,t2)

#define List(type) name2(type,PList)
#define Listlink(type) name2(type,PList_link)
#define List_iterator(type) name2(type,PList_iterator)

#define	BACKWARD	-1
#define RESET		0
#define FORWARD		1


#define Listdeclare(type)						\
  class	List(type);							\
  class	List_iterator(type)
#define Listdefine(type)						\
  typedef	type*	type/**/P;					\
  extern GPT errorhandler(List,type);					\
  extern GPT sethandler(List,type,GPT);					\
									\
  class Listlink(type) : public EKSObject {				\
  public:								\
	Listlink(type)*	next;						\
	Listlink(type)*	prev;						\
	type*		entry;						\
									\
	Listlink(type)(type* e, Listlink(type)* a, Listlink(type)* b);	\
									\
	Listlink(type) (APL* theAPL);			/*ONTOS stuff*/	\
	void	putObject(Boolean deallocate = FALSE);			\
	void	deleteItem(Boolean deallocate);				\
	Type*	getDirectType();					\
  };									\
									\
  class	List(type) : public EKSObject  {				\
  protected:								\
  friend	List_iterator(type);					\
	Listlink(type)*	head;						\
	Listlink(type)*	tail;						\
	int		length;						\
	Boolean		saved;						\
	Listlink(type)*	find(type*);					\
  public:								\
	List(type) ();							\
	List(type) (type* a);						\
	List(type) (List(type)& lst);			/*shallow copy*/\
	List(type) (APL* theAPL);			/*ONTOS stuff*/	\
	~List(type) ();							\
									\
	void	Destroy (Boolean aborted = FALSE);	/*ONTOS stuff*/	\
	void	putObject(Boolean deallocate);				\
	void	deleteObject(OC_Boolean deallocate);			\
	void	deleteList(OC_Boolean deallocate);			\
	Type*	getDirectType();					\
									\
	List(type)&	operator=(List(type)& lst);	/*shallow copy*/\
	List(type)&	operator+=(List(type)& lst);	/*shallow copy*/\
  friend List(type)	operator+(List(type)& lst);	/*shallow copy*/\
									\
	int	size();							\
	void	append(type* a);					\
	void	append(type* a, type* b);				\
	void	insert(type* a);					\
	void	insert(type* a, type* b);				\
	void	remove(type* a);					\
	type*	first();						\
	type*	last();							\
	void	clear();						\
  };									\
									\
									\
  class	 List_iterator(type) {						\
  protected:								\
	Listlink(type)*	next_item;					\
	List(type)*	list;						\
  public:								\
	List_iterator(type)    (List(type)* lst);			\
	List_iterator(type)    (List_iterator(type)& lst_iter);		\
									\
	List_iterator(type)&   operator=(List_iterator(type)& lst_iter);\
									\
	type* operator() (int d);					\
	type* operator[] (int a);					\
	int	size();							\
  }


#define Listimplement(type)						\
  typedef	type*	type/**/P;					\
  extern	error(int err_no, char* err_str);			\
  Type*	List(type)_Type_pointer;					\
  Type*	Listlink(type)_Type_pointer;					\
  GPT	errorhandler(List,type) = error;				\
  GPT	sethandler(List,type, GPT a)					\
  {									\
	GPT oo = errorhandler(List,type);				\
	errorhandler(List,type) = a;					\
	return oo;							\
  };									\
									\
  Listlink(type)::Listlink(type)(type* e, Listlink(type)* a,		\
					  Listlink(type)* b)		\
					: EKSObject(NULLPTR(Metaclass))	\
  {									\
	entry = e; next = b; prev = a;					\
	if (a)    a->next = this;					\
	if (b)    b->prev = this;					\
  };									\
									\
  Listlink(type)::Listlink(type)(APL* theAPL) : EKSObject(theAPL)	\
  {									\
	if (!entry)   return;						\
									\
	RETRIEVE(entry);						\
	if (!entry)							\
		callerror(List, type, 1,      /* entries not saveable */\
			  "List(A)::List(A)(APL) - entry not in db");	\
									\
	if (next)   RETRIEVE(next);	    /* NB retrieves ALL links */\
  };									\
									\
  void	Listlink(type)::putObject(Boolean deallocate)			\
				/* NB. only called for head of list */	\
  {									\
	initDirectType(getDirectType());				\
									\
 	STORE(entry);							\
									\
	if(next)   STORE(next);		       /* NB stores ALL links */\
									\
	EKSObject::putObject(deallocate);				\
  };									\
									\
  void	Listlink(type)::deleteItem(Boolean deallocate)			\
  {									\
 	FORGET(entry);							\
  };									\
									\
  Type*	Listlink(type)::getDirectType()					\
  {									\
	return TYPE_OF(type\
PList_link);								\
  };									\
									\
									\
		/****************************************/		\
									\
  Listlink(type)*	List(type)::find(type* where)			\
  {	Listlink(type)* lp;						\
	for (lp = head; lp->entry != where  &&  lp != 0; lp = lp->next);\
	return lp;							\
  };									\
									\
									\
  List(type)::List(type)() : EKSObject(NULLPTR(Metaclass))		\
  {									\
	head = tail = 0;						\
	length = 0;							\
	saved = FALSE;							\
  };									\
									\
  List(type)::List(type)(type* a) : EKSObject(NULLPTR(Metaclass))	\
  {									\
	head = tail = new Listlink(type)(a, 0, 0);			\
	length = 1;							\
	saved = FALSE;							\
  };									\
									\
  List(type)::List(type)(List(type)& lst) : EKSObject(NULLPTR(Metaclass))\
  {									\
	head = tail = 0;						\
	length = 0;							\
	(void) operator+=(lst);						\
	saved = FALSE;							\
  };									\
									\
  List(type)::List(type)(APL* theAPL) : EKSObject(theAPL)		\
  {									\
	saved = TRUE;							\
	if (!length)					/* empty list */\
		return;							\
				/* retrieve link objects & entries */	\
	RETRIEVE(head);		/*   APL ctor for head gets all links */\
									\
	tail = head;					/* reset tail */\
 	while (tail->next) {						\
		tail = tail->next;					\
	};								\
  };									\
									\
  List(type)::~List(type)()						\
  {									\
	Destroy(FALSE);							\
  };									\
									\
									\
  void	List(type)::Destroy(Boolean aborted)				\
  {									\
	saved = FALSE;			     /* don't delete from db */	\
	clear();							\
	if (aborted)							\
		EKSObject::Destroy(aborted);				\
  };									\
									\
  void	List(type)::putObject(Boolean deallocate)			\
  {									\
	if (head) {							\
		if (!OC_lookup("type")) {				\
			callerror(List,type,1,/* entries not saveable */\
		   "List(type)::putList() - entries not ONTOS objects");\
	    		return;						\
		};							\
				/* save all link objects & entries */	\
		STORE(head);	/*     head->putObject puts ALL links */\
	};								\
									\
				    	/* need directType setup */	\
	initDirectType(getDirectType());				\
									\
	saved = TRUE;							\
									\
	EKSObject::putObject(deallocate);	/* save list itself */	\
  };									\
									\
  void	List(type)::deleteObject(OC_Boolean deallocate)			\
  {									\
	if (!saved)							\
	    	return;							\
									\
	saved = FALSE;							\
									\
	Listlink(type)* nextlink = head;       /* zap links only */	\
	while (nextlink) {						\
		nextlink->deleteObject(deallocate);			\
		nextlink = nextlink->next;				\
	};								\
									\
	if (deallocate) {		/* cos deleteObject calls dtor*/\
		length = 0;						\
		head = tail = NULLPTR(Listlink(type));			\
	};								\
									\
	EKSObject::deleteObject(deallocate);	/* zap list itself */	\
  };									\
									\
  void	List(type)::deleteList(OC_Boolean deallocate)			\
  {									\
	if (!saved)							\
	    	return;							\
									\
	Listlink(type)* nextlink = head;       /* zap entries only */	\
	while (nextlink) {						\
		nextlink->deleteItem(deallocate);			\
		nextlink = nextlink->next;				\
	};								\
									\
	deleteObject(deallocate);       /* zap list & link objects */	\
  };									\
									\
									\
  Type*	List(type)::getDirectType()					\
  {									\
	return TYPE_OF(type\
PList);									\
  };									\
									\
									\
  List(type)&	List(type)::operator=(List(type)& lst)			\
  {									\
	if (this == &lst)   return (*this);				\
									\
	clear();							\
	return operator+=(lst);						\
  };									\
									\
									\
  List(type)&	List(type)::operator+=(List(type)& lst)			\
  {									\
	Listlink(type)* nextlink = lst.head;				\
	while (nextlink) {						\
		tail = new Listlink(type)(nextlink->entry, tail, 0);	\
		if (saved)   tail->putObject(FALSE);			\
		if (!head)   head = tail;				\
		length++;						\
		nextlink = nextlink->next;				\
	};								\
	return *this;							\
  };									\
									\
									\
  List(type)	operator+(List(type)& lst1, List(type)& lst2)		\
  {									\
	List(type) newlst(lst1);					\
	newlst += lst2;							\
									\
	return newlst;							\
  };									\
									\
									\
  void	List(type)::append(type* a)					\
  {									\
	tail = new Listlink(type)(a, tail, 0);				\
	if (saved)   tail->putObject(FALSE);				\
	if (!head)   head = tail;					\
	length++;							\
  };									\
									\
  void	List(type)::append(type* a, type* where)			\
  {	Listlink(type)*	lp;						\
	if (!head  ||  !where) {	/* empty list || null where */	\
		append (a);		/*       put at tail */		\
		return;							\
	};								\
					/* locate 'where' on list */	\
	if (!(lp = find(where))) {					\
		callerror(List, type, 1,	/* not found */		\
		  "List(type)::append(type*,type*) - arg2 not on list");\
	    	return;							\
	};								\
	if (!lp->next)							\
		tail = new Listlink(type)(a, lp, lp->next);		\
	else								\
		(void) new Listlink(type)(a, lp, lp->next);		\
	if (saved)   lp->next->putObject(FALSE);			\
	length++;							\
  };									\
									\
  void	List(type)::insert(type* a)		/* insert before head */\
  {									\
	head = new Listlink(type)(a, 0, head);				\
	if (saved)   head->putObject(FALSE);				\
	if (!tail)   tail = head;					\
	length++;							\
  };									\
									\
  void	List(type)::insert(type* a, type* where)   /* insert before b */\
  {	Listlink(type)*	lp;						\
									\
	if (!head  ||  !where) {	/* empty list || null where */	\
		insert (a);		/*       put at head */		\
		return;							\
	};								\
					/* locate 'where' on list */	\
	if (!(lp = find(where))) {					\
		callerror(List, type, 2,	/* not found */		\
		  "List(type)::insert(type*,type*) - arg2 not on list");\
	    	return;							\
	};								\
									\
	if (!lp->prev)							\
		head = new Listlink(type)(a, lp->prev, lp);		\
	else								\
		(void) new Listlink(type)(a, lp->prev, lp);		\
	if (saved)   lp->prev->putObject(FALSE);			\
	length++;							\
  };									\
									\
									\
  void	List(type)::remove(type* what)					\
  {	Listlink(type)*	lp;						\
									\
	if (!head  ||  !what  ||  !(lp = find (what))) {		\
		callerror(List, type, 3,  /* empty list || null what */	\
		  "List(type)::remove(type*) - arg1 not on list");	\
		return;							\
	};								\
									\
	if (!lp->prev)				/* link back */		\
		head = lp->next;					\
	else								\
		lp->prev->next = lp->next;				\
	if (!lp->next)				/* link forward */	\
		tail = lp->prev;					\
	else								\
		lp->next->prev = lp->prev;				\
									\
	if (saved)   lp->deleteObject(FALSE);	/* rm link from db */	\
	delete lp;				/* free link storage */	\
	length--;							\
  };									\
									\
									\
  int	List(type)::size()						\
  {									\
	return length;							\
  };									\
									\
									\
  type*	List(type)::first()						\
  {									\
	if (!head) {							\
		callerror(List, type, -4,  /* empty list */		\
		  "List(type)::first() - empty list");			\
		return (type*) 0;					\
	};								\
	return (head->entry);						\
  };									\
									\
									\
  type*	List(type)::last()						\
  {									\
	if (!head) {							\
		callerror(List, type, -5,  /* empty list */		\
		  "List(type)::last() - empty list");			\
		return (type*) 0;					\
	};								\
	return (tail->entry);						\
  };									\
									\
									\
  void	List(type)::clear()						\
  {									\
	if (!head)			/* empty list */		\
		return;							\
									\
	length = 0;							\
									\
	while (head != 0) {		/* free all link storage */	\
		tail = head->next;					\
		if (saved)   head->deleteObject(FALSE);	/* rm from db */\
		delete tail;						\
		head = tail;						\
	};								\
  };									\
									\
									\
		/****************************************/		\
									\
  List_iterator(type)::List_iterator(type) (List(type)* lst)		\
  {									\
	list = lst;							\
	next_item = 0;							\
  };									\
									\
   List_iterator(type)::List_iterator(type) (List_iterator(type)& l_itr)\
  {									\
	list = l_itr.list;						\
	next_item = l_itr.next_item;					\
  };									\
									\
									\
  List_iterator(type)&   List_iterator(type)::operator=(		\
					 List_iterator(type)& lst_iter) \
  {									\
	if (this == &lst_iter)   return (*this);			\
									\
	list = lst_iter.list;						\
	next_item = lst_iter.next_item;					\
									\
	return *this;							\
  };									\
									\
  type*	List_iterator(type)::operator()(int direction)			\
  {									\
	if (!list->head) {						\
		callerror(List, type, -6,  /* empty list */		\
		  "List_iterator::() - empty list");			\
		return (type*) 0;					\
	};								\
									\
	if (!direction || next_item==(direction>0? list->tail: list->head)){\
		next_item = 0;			/* off end of list */	\
		return 0;						\
	};								\
	if (!next_item)				/* null => restart */	\
		next_item = (direction>0 ? list->head:  list->tail);	\
	else								\
		next_item = (direction>0? next_item->next: next_item->prev);\
	return (next_item->entry);					\
  };									\
									\
  type*	List_iterator(type)::operator[](int index)			\
  {	Listlink(type)*	lp = list->head;				\
	int		count = 0;					\
									\
	if (!list->head) {						\
		callerror(List, type, 7,  /* empty list */		\
		  "List_iterator::[] - empty list");			\
		return (type*) 0;					\
	};								\
									\
	for (; count < index  &&  lp != list->tail; count++, lp = lp->next);\
	if (count != index) {						\
		callerror(List, type, 8,  /* not on list */		\
		  "List_iterator::[] - index out of range");		\
		return (type*) 0;					\
	};								\
									\
	return lp->entry;						\
  };									\
									\
									\
  int	List_iterator(type)::size()					\
  {									\
	return list->length;						\
  }

#endif
