#include	"Template.h"
#include	"Metaproto.h"


Metaproto*	mk_proto(char* classname)
{
	DEBUG1	<<"mk_proto(" << classname <<")\n";

	if (!strcmp(classname, "Context_1a")) {
		static char*	caller_types[] = {
							0 };
		static char*	aux_classes[] = {
							"Site_basic",
							0 };
		return (Metaproto*) new Metaproto(
				"Context_1a", "Context", "Context_1a_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Site_basic")) {
		static char*	caller_types[] =	{
							0 };
		static char*	aux_classes[] = 	{
							"Climate_met",
							0 };
		return (Metaproto*) new Metaproto(
				"Site_basic", "Site", "Site_basic_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Climate_met")) {
		static char*	caller_types[] = {
							0 };
		static char*	aux_classes[] = {
							0 };
		return (Metaproto*) new Metaproto(
				"Climate_met", "Climate", "Climate_met_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Context_1b")) {
		static char*	caller_types[] = {
							0 };
		static char*	aux_classes[] = {
							"Site_sun",
							0 };
		return (Metaproto*) new Metaproto(
				"Context_1b", "Context", "Context_1b_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Site_sun")) {
		static char*	caller_types[] = {
							0 };
		static char*	aux_classes[] = {
							"Climate_met",
							"Sun_basic",
							"Sky_basic",
							0 };
		return (Metaproto*) new Metaproto(
				"Site_sun", "Site", "Site_sun_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Sun_basic")) {
		static char*	caller_types[] =	{
							0 };
		static char*	aux_classes[] =	{
							0 };
		return (Metaproto*) new Metaproto(
				"Sun_basic", "Sun", "Sun_basic_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Sky_basic")) {
		static char*	caller_types[] =	{
							0 };
		static char*	aux_classes[] =	{
							"Sky_irradiance",
							"Sky_termperature",
							0 };
		return (Metaproto*) new Metaproto(
				"Sky_basic", "Sky", "Sky_basic_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Perez")) {
		static char*	caller_types[] =	{
							0 };
		static char*	aux_classes[] =	{
							0 };
		return (Metaproto*) new Metaproto(
				"Perez", "Sky_irradiance", "Perez_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Berdahl_and_Martin")  ||
	         !strcmp(classname, "B&M")) {
		static char*	caller_types[] =	{
							0 };
		static char*	aux_classes[] =	{
							0 };
		return (Metaproto*) new Metaproto(
				"Berdahl_and_Martin", "Sky_temperature", "Berdahl_and_Martin_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Context_2a")) {
		static char*	caller_types[] =	{
							0 };
		static char*	aux_classes[] =	{
						        "Site_basic",
						        "Construction_basic",
							0 };
		return (Metaproto*) new Metaproto(
				"Context_2a", "Context", "Context_2a_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Construction_basic")) {
		static char*	caller_types[] =	{
							0 };
		static char*	aux_classes[] =	{
						        "Surface_basic",
						        "Layer_basic",
							0 };
		return (Metaproto*) new Metaproto(
				"Construction_basic", "Construction", "Construction_basic_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Surface_basic")) {
		static char*	caller_types[] =	{
							0 };
		static char*	aux_classes[] =	{
							0 };
		return (Metaproto*) new Metaproto(
				"Surface_basic", "Surface", "Surface_basic_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Layer_basic")) {
		static char*	caller_types[] =	{
							0 };
		static char*	aux_classes[] =	{
							0 };
		return (Metaproto*) new Metaproto(
				"Layer_basic", "Layer", "Layer_basic_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Context_2b")) {
		static char*	caller_types[] =	{
							0 };
		static char*	aux_classes[] =	{
						        "Site_basic",
						        "Construction_es",
							"Conduction_fd",
						        "Solver",
							0 };
		return (Metaproto*) new Metaproto(
				"Context_2b", "Context", "Context_2b_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Construction_es")) {
		static char*	caller_types[] = {
							0 };
		static char*	aux_classes[] =	{
						        "Surface_es",
						        "Layer_es",
							0 };
		return (Metaproto*) new Metaproto(
				"Construction_es", "Construction", "Construction_es_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Surface_es")) {
		static char*	caller_types[] =	{
							"Construction_es",
							0 };
		static char*	aux_classes[] =	{
							0 };
		return (Metaproto*) new Metaproto(
				"Surface_es", "Surface", "Surface_es_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Layer_es")) {
		static char*	caller_types[] =	{
							0 };
		static char*	aux_classes[] =	{
						        "Conduction",
							0 };
		return (Metaproto*) new Metaproto(
				"Layer_es", "Layer", "Layer_es_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Conduction_fd")) {
		static char*	caller_types[] =	{
							0 };
		static char*	aux_classes[] =	{
							0 };
		return (Metaproto*) new Metaproto(
				"Conduction_fd", "Conduction", "Conduction_fd_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Gauss_column_pivot")) {
		static char*	caller_types[] = {
							0 };
		static char*	aux_classes[] = {
							0 };
		return (Metaproto*) new Metaproto(
				"Gauss_column_pivot", "Solver", "Gauss_column_pivot_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Context_3a")) {
		static char*	caller_types[] = {
							0 };
		static char*	aux_classes[] = {
							"Site_sun",
							"Building",
							0 };
		return (Metaproto*) new Metaproto(
				"Context_3a", "Context", "Context_3a_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Building")) {
		static char*	caller_types[] = {
							0 };
		static char*	aux_classes[] = {
							"Room",
							"Construction",
							0 };
		return (Metaproto*) new Metaproto(
				"Building", "Building", "Building_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Space")) {
		static char*	caller_types[] = {
							0 };
		static char*	aux_classes[] = {
							"AirVolume",
							0 };
		return (Metaproto*) new Metaproto(
				"Space", "Space", "Space_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Room")) {
		static char*	caller_types[] = {
							"Building",
							0 };
		static char*	aux_classes[] = {
							"AirVolume",
							"HeatSource",
							0 };
		return (Metaproto*) new Metaproto(
				"Room", "Room", "Room_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "AirVolume")) {
		static char*	caller_types[] = {
							"Room",
							0 };
		static char*	aux_classes[] = {
							0 };
		return (Metaproto*) new Metaproto(
				"AirVolume", "AirVolume", "AirVolume_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "HeatSource")) {
		static char*	caller_types[] = {
							0 };
		static char*	aux_classes[] = {
							0 };
		return (Metaproto*) new Metaproto(
				"HeatSource", "HeatSource", "HeatSource_def",
				caller_types, aux_classes);
/*****	} else if (!strcmp(classname, "Context_3b")) {
		static char*	caller_types[] = {
							0 };
		static char*	aux_classes[] = {
							"Site_sun",
							"Building_es",
							"Convection_fd_1",
						        "Radiation_fd_1",
							0 };
		return (Metaproto*) new Metaproto(
				"Context_3b", "Context", "Context_3b_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Building_es")) {
		static char*	caller_types[] = {
							0 };
		static char*	aux_classes[] = {
							"Room_es",
							"Construction_es",
							0 };
		return (Metaproto*) new Metaproto(
				"Building_es", "Building", "Building_es_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Room_es")) {
		static char*	caller_types[] = {
							"Building_es",
							0 };
		static char*	aux_classes[] = {
							"AirVolume_es",
							"HeatSource",
							0 };
		return (Metaproto*) new Metaproto(
				"Room_es", "Room", "Room_es_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "AirVolume_es")) {
		static char*	caller_types[] = {
							"Room_es",
							0 };
		static char*	aux_classes[] = {
							0 };
		return (Metaproto*) new Metaproto(
				"AirVolume_es", "AirVolume", "AirVolume_es_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Convection_fd_1")) {
		static char*	caller_types[] ={
							0 };
		static char*	aux_classes[] =	{
							0 };
		return (Metaproto*) new Metaproto(
				"Convection_fd_1", "Convection", "Convection_fd_1_def",
				caller_types, aux_classes);
	} else if (!strcmp(classname, "Radiation_fd_1")) {
		static char*	caller_types[] ={
							0 };
		static char*	aux_classes[] =	{
							0 };
		return (Metaproto*) new Metaproto(
				"Radiation_fd_1", "Radiation", "Radiation_fd_1_def",
				caller_types, aux_classes);
*****/	};

	cerr << "make_meta_for: don't know how to make metaclass for "<< classname <<"\n";
	return NULLPTR(Metaproto);
};
