#include	"building/Surface_es_def.h"

#include	<string.h>
#include	"infrastructure/Metaclass.h"

static	char*	class_name = "the surface_es_def";
Type*	Surface_basic_def_Type_pointer;


Surface_es_def::Surface_es_def(Metaclass* meta)  : Surface_basic_def(meta)
{
	DEBUG	<< "Surface_es_def::Surface_es_def(" << meta->oid() << ")\n";

	name(class_name);
	directType(TYPE_OF(Surface_basic_def));

	char	buffer[256];
	cout << "which Conduction theory object for Surface (name)? ";
	cin >> buffer;
	the_conduction_name = strdup(buffer);
};

Surface_es_def::Surface_es_def (Finish& fin, Polygon* poly,
				ThermalResistance resist, char* a_conduction_name)
			: Surface_basic_def(fin, poly, resist)
{
	DEBUG << "Surface_es::Surface_es(Finish* fin, Polygon* poly, ThermalResistance resist, char* a_conduyction_name)\n";

	name(class_name);
	directType(TYPE_OF(Surface_basic_def));

	the_conduction_name = a_conduction_name;
};

Surface_es_def::Surface_es_def(APL* theAPL) : Surface_basic_def(theAPL)
{
	RETRIEVE(the_caller);
};

Surface_es_def::~Surface_es_def()
{
	DEBUG << "Surface_es_def::~Surface_es_def()\n";

	Destroy(FALSE);
};


void	Surface_es_def::Destroy(Boolean aborted)
{
	DEBUG << "Surface_es_def::Destroy(Boolean aborted)\n";

	if (aborted)
		Surface_basic_def::Destroy(aborted);
};

void	Surface_es_def::putObject(Boolean deallocate)
{
	DEBUG << "Surface_es_def::putObject(Boolean deallocate)\n";

	STORE(the_caller);

	Surface_basic_def::putObject(deallocate);
};

void	Surface_es_def::deleteObject(Boolean deallocate)
{
	DEBUG << "Surface_es_def::deleteObject(Boolean deallocate)\n";

	Surface_basic_def::deleteObject(deallocate);
};


char*		Surface_es_def::conduction_name()
{
	DEBUG1	<< "char::Surface_es_def::conduction_name()\n";

	return the_conduction_name;
};

void		Surface_es_def::caller(EKSObject* a_caller)
{
	DEBUG1	<< "EKSObject*	caller(EKSObject* a_caller)\n";

	the_caller = a_caller;
};

EKSObject*	Surface_es_def::caller()
{
	DEBUG1	<< "EKSObject*	caller()\n";

	return the_caller;
};


void	Surface_es_def::description(Metaclass* meta, ostream& s)
{
	s << "Surface_es : ";
	Surface_basic_def::description(meta, s);
	s << indent << "conduction theory name for surface: \n";
};
