#ifndef CONTEXT_2B_H
#define CONTEXT_2B_H

#include "context/Context_domain_c.h"
#include "context/Context_2a.h"
#include "context/Context_2b_def.h"
class	Construction_es;
class	Conduction_fd;
class	Gauss_column_pivot;

extern	Type*	Context_2b_Type_pointer;


class Context_2b : public Context_domain_c, public Context_2a {
protected:
public:
	Context_2b(Metaclass* meta, Context_2b_def* def);
	Context_2b(APL* theAPL);
////	~Context_2b();

	Type*			getDirectType();

	Construction_es*	construction();
	Conduction_fd*		conduction();
	Gauss_column_pivot*	solver();

	virtual	void		simulate();
};


inline
Type*	Context_2b::getDirectType()
{
	return TYPE_OF(Context_2b);
};

inline
Construction_es*	Context_2b::construction()
{				// cast guaranteed by Metaclasses
	return (Construction_es*)the_construction;
};

inline
Conduction_fd*	Context_2b::conduction()
{				// cast guaranteed by Metaclasses
	return (Conduction_fd*)Context_domain_c::conduction();
};

inline
Gauss_column_pivot*	Context_2b::solver()
{				// cast guaranteed by Metaclasses
	return (Gauss_column_pivot*)Context_domain_c::solver();
};

#endif
