#include	"Context_2b_def.h"

#include	<string.h>
#include	<stdlib.h>
#include	"Metaclass.h"
////#include	"Construction_es_def.h"		// for debug oid()
#include	"Conduction_fd_def.h"		// for debug oid()
#include	"Solver_def.h"		// for debug oid()


static	char*	class_name = "the context_2b_def";
/**/static	char*	class_type = "Context_2b_def";


Context_2b_def::Context_2b_def(Metaclass* meta)
				: Context_domain_c_def(meta), Context_2a_def(meta)
{
	DEBUG	<< "Context_2b_def::Context_2b_def(" << meta->oid() << ")\n";

	name(class_name);
/**/	my_type = class_type;

	conduction = (Conduction_fd_def*)meta->make_def_for("Conduction");
	solver = (Solver_def*)meta->make_def_for("Solver");
};

Context_2b_def::Context_2b_def(Site_sun_def* a_site_def, Construction_es_def* a_constr_def, Conduction_fd_def* a_conduct_def, Solver_def* a_solver_def)
			: Context_domain_c_def((Conduction_def*)a_conduct_def, a_solver_def),
			Context_2a_def(a_site_def, (Construction_def*)a_constr_def)
{
	DEBUG	<< "Context_2b_def::Context_2b_def(" << a_site_def->oid() << ")\n";

	name(class_name);
/**/	my_type = class_type;

	conduction = a_conduct_def;
	solver = a_solver_def;
};

Context_2b_def::~Context_2b_def()
{
	DEBUG << "Context_2b_def::~Context_2b_def()\n";
};




void	Context_2b_def::description(Metaclass* meta, ostream& s)
{
	s << "Context_2b : ";
	s << "->  Conduction\n";
	strcat(indent,"    ");
        meta->describe_def_for("Conduction", s);
	indent[strlen(indent-4)] = '\0';
	s << "->  Solver\n";
	indent[strlen(indent)] = ' ';
        meta->describe_def_for("Solver", s);
	indent[strlen(indent-4)] = '\0';
	s << "           : ";
	Context_2a_def::description(meta, s);
}
