/*
    Generic type: card reader
    Type	: Single component
    Description	: data supplier, n parameters,
		  values and types to be defined at run time
    Note	: card-reader copies parameters to both in-vector and out-vector.
		  in-vector will never be used.
*/

#ifndef ACARD_READER_H
#define ACARD_READER_H

#include "Mixed_vector.h"
#include "AComponent.h"
class Metaclass;
class ACard_reader_def;

class ACard_reader : public AComponent {
private:
	Mixed_vector	the_parameters;
	Variable_type*	the_parameter_types;
	void		initialise();
public:
	ACard_reader(Metaclass* meta, ACard_reader_def* def);
	~ACard_reader();
/*
	int		no_in_nodes();
	int		no_out_nodes();
virtual	Mixed_vector&	out_vector();
virtual	Variable_type*	out_vector_type();
virtual	Mixed_vector&	in_vector();
virtual	Variable_type*	in_vector_type();
*/
virtual	void		create_me(EKSObject* caller);
};

#endif
