#ifndef BERDAHL_AND_MARTIN_H
#define BERDAHL_AND_MARTIN_H

#include	"site/Sky_temperature.h"
#include	"site/Berdahl_and_Martin_def.h"

extern	Type*	Berdahl_and_Martin_Type_pointer;

/*
** basic class for the calculation of sky temperature.
*/


class Berdahl_and_Martin : public Sky_temperature {
protected:
	/* The following variables are used in the calculation of cloud cover. */
	float CLOUDC;
	float CLOUD1;
	float CLOUD2;
	float CLOUD3;
public:
	Berdahl_and_Martin(Metaclass* meta, Berdahl_and_Martin_def* def);
	Berdahl_and_Martin(Berdahl_and_Martin& s);
	Berdahl_and_Martin(APL* theAPL);

	Type*	getDirectType();

	Berdahl_and_Martin& operator=(Berdahl_and_Martin& s);

virtual	Temperature	execute(ClimateRecord& a_clm_rec,
				Sun_position& a_sun_pos,
				Time_of_day& a_time_of_day);
};



inline
Type*	Berdahl_and_Martin::getDirectType()
{
	return TYPE_OF(Berdahl_and_Martin);
};

#endif
