#ifndef	SHORTWAVE_SMEAR_H
#define	SHORTWAVE_SMEAR_H

#include	"theory/Shortwave.h"
#include	"theory/Shortwave_def.h"
class	Shortwave_beam;
#include	"list.h"
template_declare(List,Shortwave_beam);
class	Building;
class	Room;
class	Surface;

extern Type*	Shortwave_smear_Type_pointer;


class	Shortwave_smear : public Shortwave {
public:
	Shortwave_smear(Metaclass* meta, Shortwave_def* def);
	Shortwave_smear(Shortwave_smear& sw);
	Shortwave_smear(APL* theAPL);
	~Shortwave_smear();

	Type*	getDirectType();

	List(Shortwave_beam)&	building_response(List(Shortwave_beam)& incident,
						  Building& the_building);
	List(Shortwave_beam)&	room_response(List(Shortwave_beam)& incident,
					      Room& the_room);
	List(Shortwave_beam)&	surface_response(Shortwave_beam& incident,
						 Surface& the_surface);
};


inline
Type*	Shortwave_smear::getDirectType()
{
	return TYPE_OF(Shortwave_smear);
};
#endif
